using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Grouping;
using System.Collections;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace WindowsApplication31
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        DataTable dt;
        private void Form1_Load(object sender, EventArgs e)
        {

            #region datatable
           dt = new DataTable("MyTable");

            int nCols = 4;
            int nRows = 20;
            Random r = new Random(123345345);
            string dateColumnName = "date";
            for (int i = 0; i < nCols; i++)
                dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));
            dt.Columns.Add(new DataColumn(dateColumnName, typeof(DateTime)));


            for (int i = 0; i < nRows; ++i)
            {
                DataRow dr = dt.NewRow();
                for (int j = 0; j < nCols; j++)
                    dr[j] = (j==0) ? i : r.Next(10);
                dr[dateColumnName] = DateTime.Now.AddHours(48 - r.Next(96));
                dt.Rows.Add(dr);
            }

            #endregion

            this.gridGroupingControl1.DataSource = dt;

            //create a custom filter condition
            FilterCondition fc = new FilterCondition();
            fc.CustomFilter = new MyCustomFilter(); //custom filter object that supports ICustomFilter
            fc.CompareOperator = FilterCompareOperator.Custom;
            fc.CompareText = dateColumnName;

            //create a RecordFilterDescriptor to use the custom filter
            RecordFilterDescriptor rfd = new RecordFilterDescriptor("DateCheck", fc);
            
            //create a condition format that uses the filter descriptor
            GridConditionalFormatDescriptor cfd = new GridConditionalFormatDescriptor("DataCheck");    
            cfd.Appearance.AnyRecordFieldCell.BackColor = Color.Red;
            cfd.RecordFilters.Add(rfd);

            //apply the condition format to the grid
            this.gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(cfd);

          }

        class MyCustomFilter : ICustomFilter
        {
           public MyCustomFilter()
            {
            }

            #region ICustomFilter Members

            public bool CompareDescriptor(FilterCondition filterCondition, Record record)
            {
                string fieldName = filterCondition.CompareText;
                object o = record.GetValue(fieldName);
                if (o != null)
                {
                    DateTime dt = (DateTime)Convert.ChangeType(record.GetValue(fieldName), typeof(DateTime));
                    return dt > DateTime.Now;
                }

                return false;
            }

            #endregion

        }

    }
}